#include "dominantseptakkord.h"

// es scheint nicht klar, ob die Anzahl der Töne fest ist oder variabel
// static-Element wird außerhalb der Klassendeklaration initialisiert

zufall dominantseptakkord::m_z;

const int prime = 0;
const int grosse_terz = 17;
const int quinte = 31;
const int kleine_sexte = 36;
// const int kleine_septime = 43; //Naturseptime
const int kleine_septime = 44; //Pythagoreische Septime
const int oktave = 53;
const int terzschichtung[] = {prime, grosse_terz, quinte, kleine_septime};
const int anzahl_der_stimmen = 4;

dominantseptakkord::dominantseptakkord(int untergrenze, int obergrenze)
{
  m_rein = new int [anzahl_der_stimmen];
  m_verstimmt = new int [anzahl_der_stimmen];
  m_akkordton = new int [anzahl_der_stimmen];
  if(m_rein == NULL || m_verstimmt == NULL || m_akkordton == NULL)
    exit(1);
  m_anzahl_toene = anzahl_der_stimmen;
  m_untergrenze = untergrenze + 1; // damit alle Verstimmungen nach unten möglich bleiben
  m_obergrenze = obergrenze - 1; // auch nach oben
  belegung();
}

dominantseptakkord::~dominantseptakkord()
{
  delete[] m_rein;
  delete[] m_verstimmt;
  delete[] m_akkordton;
}

dominantseptakkord::dominantseptakkord(const dominantseptakkord& ausgangswert)
{
  m_anzahl_toene = ausgangswert.m_anzahl_toene;
  m_untergrenze = ausgangswert.m_untergrenze;
  m_obergrenze = ausgangswert.m_obergrenze;
  m_rein = new int [anzahl_der_stimmen];
  m_verstimmt = new int [anzahl_der_stimmen];
  m_akkordton = new int [anzahl_der_stimmen];
  if(m_rein == NULL || m_verstimmt == NULL || m_akkordton == NULL)
    exit(1);
  for(int i = 0; i < anzahl_der_stimmen; i++)
    {
      m_rein[i] = ausgangswert.m_rein[i];
      m_verstimmt[i] = ausgangswert.m_verstimmt[i];
      m_akkordton[i] = ausgangswert.m_akkordton[i];
    }
}

void dominantseptakkord::belegung()
{
// Verteilung der Akkordtöne auf die Stimmen
  int index_bass, index_sopran, index_mittelstimme_1, index_mittelstimme_2;
  index_bass = m_z.zufallszahl_bis(4);
  int d_bass_sopran = m_z.zufallszahl_bis(3) + 1;
  index_sopran = (index_bass + d_bass_sopran) % 4;
  int d_sopran_mittelstimme_1 = ((d_bass_sopran == 2) ? 1 : 2);
  int d_mittelstimme_1_mittelstimme_2 = 4 - d_bass_sopran;
  index_mittelstimme_1 = (index_sopran + d_sopran_mittelstimme_1) % 4;
  index_mittelstimme_2 = (index_mittelstimme_1 + d_mittelstimme_1_mittelstimme_2) % 4;

  // Bestimmung der Töne
  m_rein[0] = terzschichtung[index_bass];
  m_rein[1] = terzschichtung[index_mittelstimme_1];
  m_rein[2] = terzschichtung[index_mittelstimme_2];
  m_rein[3] = terzschichtung[index_sopran];

// Anpassung der Oktavlagen
  m_rein[3] = mindestens_mod(m_rein[3], m_rein[0] + kleine_sexte, oktave);
  m_rein[1] = hoechstens_mod(m_rein[1], m_rein[3], oktave);
  m_rein[2] = hoechstens_mod(m_rein[2], m_rein[3], oktave);

  if(m_rein[1] > m_rein[2]) // Mittelstimmen aufsteigend
    {
      int zwischen = m_rein[2];
      m_rein[2] = m_rein[1];
      m_rein[1] = zwischen;
    }

// zufällige Transposition
// m_rein[3] <= m_obergrenze
// m_untergrenze <= bass
// m_untergrenze (+ m_rein[3] - bass) <= bass(+ m_rein[3] - bass)
// m_untergrenze + m_rein[3] - bass <= m_rein[3] <= m_obergrenze
// m_untergrenze + m_rein[3] - bass <= m_obergrenze
// m_rein[3] - bass <= m_obergrenze - m_untergrenze
  int schwankungsbreite = m_obergrenze + m_rein[0] - m_untergrenze - m_rein[3];
  int transposition = - m_rein[0] + m_untergrenze + m_z.zufallszahl_bis(schwankungsbreite + 1);

  for(int i = 0; i < m_anzahl_toene; i++)
    m_verstimmt[i] = m_rein[i] += transposition;

  // Verstimmung
  int verstimmung = m_z.zufallszahl_bis(8);
  int verstimmte_stimme = (verstimmung >> 1);
  int verstimmungs_betrag = 1 - 2 * (verstimmung & 1);
  m_verstimmt[verstimmte_stimme] += verstimmungs_betrag;
  
  identifikation_akkordton(m_rein[0], m_rein[1], m_akkordton[0], m_akkordton[1]);
  identifikation_akkordton(m_rein[2], m_rein[3], m_akkordton[2], m_akkordton[3]);
}
  
void dominantseptakkord::neuer_wert()
{
  belegung();
}

dominantseptakkord& dominantseptakkord::operator=(const dominantseptakkord& rop)
{
  if(this == &rop)
    return *this;
  delete[] m_rein;
  delete[] m_verstimmt;
  delete[] m_akkordton;
  m_anzahl_toene = rop.m_anzahl_toene;
  m_untergrenze = rop.m_untergrenze;
  m_obergrenze = rop.m_obergrenze;
  m_rein = new int [anzahl_der_stimmen];
  m_verstimmt = new int [anzahl_der_stimmen];
  m_akkordton = new int [anzahl_der_stimmen];
  if(m_rein == NULL || m_verstimmt == NULL || m_akkordton == NULL)
    exit(1);
  for(int i = 0; i < anzahl_der_stimmen; i++)
    {
      m_rein[i] = rop.m_rein[i];
      m_verstimmt[i] = rop.m_verstimmt[i];
      m_akkordton[i] = rop.m_akkordton[i];
    }
  return *this;
}

int dominantseptakkord::mindestens_mod(int x, int y, int mod)
{
if(x < y)
{
if(x % mod != y % mod )
  {int zwischen = (y - x) % mod;
    return y + mod - zwischen;
  }
 else return y;
}
return y + (x - y) % mod;
}

int dominantseptakkord::hoechstens_mod(int x, int y, int mod)
{
if(x > y)
{
int zwischen = (x - y) % mod;
return y + zwischen - mod;
}
else
{
int zwischen = (y - x) % mod;
return y - zwischen;
}
}

void dominantseptakkord::identifikation_akkordton(int ton1, int ton2, int &akkordton1, int &akkordton2)
{
  int zwischen = (ton2 - ton1) % oktave;
  if(zwischen < 0)
    zwischen += oktave;
  switch(zwischen)
    {
case 9:
akkordton1 = 7;
akkordton2 = 1;
break;
case 13:
akkordton1 = 5;
akkordton2 = 7;
break;
case 14:
akkordton1 = 3;
akkordton2 = 5;
break;
case 17:
akkordton1 = 1;
akkordton2 = 3;
break;
case 22:
akkordton1 = 5;
akkordton2 = 1;
break;
case 26:
akkordton1 = 7;
akkordton2 = 3;
break;
case 27:
akkordton1 = 3;
akkordton2 = 7;
break;
case 31:
akkordton1 = 1;
akkordton2 = 5;
break;
case 36:
akkordton1 = 3;
akkordton2 = 1;
break;
case 39:
akkordton1 = 5;
akkordton2 = 3;
break;
case 40:
akkordton1 = 7;
akkordton2 = 5;
break;
case 44:
akkordton1 = 1;
akkordton2 = 7;
break;
    default:
      cout << "Fehler" << endl;
      }
  return ;
}

