#include <cstdlib>

using namespace std;

#include "frequenzen.h"
#include <cmath>

frequenzen::frequenzen()
{
  m_tabelle = new double[2 * 53 + 1]; // Zwei Oktaven und Abschlusston
    if(m_tabelle == NULL)
      exit(1);
  double komma = exp(log(2.0)/53.0); // 53-stufige Oktavteilung
  m_tabelle[93] = 880.0; // eine Oktave über Kammerton a
    for(int i = 93; i > 0; i--)
      m_tabelle[i - 1] = m_tabelle[i] / komma;
    for(int i = 93; i < 106; i++)
      m_tabelle[i + 1] = m_tabelle[i] * komma;
}

frequenzen::~frequenzen()
{
  delete[] m_tabelle;
}

double frequenzen::frequenz(int n)
{
  return m_tabelle[n];
}

