#include <iostream>
#include <fstream>
#include <ctime>
#include <locale>
#include <string.h>
using namespace std;

#include "dominantseptakkord.h"
#include "frequenzen.h"

string datum_als_string()
{
  char puffer[7];
  time_t aktuelle_zeit;
  struct tm* das_datum;
  time(&aktuelle_zeit);
  das_datum = localtime(&aktuelle_zeit);
  strftime(puffer, sizeof(puffer), "%y%m%d", das_datum);
string datum_formatiert(puffer);
 return datum_formatiert;
}

int main()
{
  frequenzen frequenztabelle;
//   for(int i = 0; i <= 53; i++)
//     cout << frequenztabelle.frequenz(i) << endl;
  
  int anzahl_akkorde = 8;
  
  dominantseptakkord der_d7(0, 106);

  string datum = datum_als_string();
  string dateiname_dominantseptakkorde_verstimmt = "dominantseptakkorde_verstimmt_" + datum + ".sco";
  string dateiname_dominantseptakkorde_kontrolle = "dominantseptakkorde_kontrolle_" + datum + ".sco";
  string dateiname_dominantseptakkorde_ausgabe_liste = "dominantseptakkorde_ausgabe_liste_" + datum + ".txt";
  string dateiname_dominantseptakkorde_akkorde = "dominantseptakkorde_akkorde_" + datum + ".txt";

  ofstream dominantseptakkorde_verstimmt(dateiname_dominantseptakkorde_verstimmt);
  ofstream dominantseptakkorde_kontrolle(dateiname_dominantseptakkorde_kontrolle);
  ofstream dominantseptakkorde_ausgabe_liste(dateiname_dominantseptakkorde_ausgabe_liste);
  ofstream dominantseptakkorde_akkorde(dateiname_dominantseptakkorde_akkorde);

  //  dominantseptakkorde_verstimmt << "f1   0    4096 10 1 .25 .111 .063 .04 " << endl;
  dominantseptakkorde_verstimmt << "f1   0    4096 10 1 .5 .333 .25 .2 .167 .143 .125 .111 .1  " << endl;
  // Flöte
  // dominantseptakkorde_verstimmt << "f1   0    4096 10 1 .45 .71 .16 .14 .032 .013 .01" << endl;
    dominantseptakkorde_verstimmt << ";ins	strt	dur	amp(p4)	freq(p5)" << endl;
    //  dominantseptakkorde_kontrolle << "f1   0    4096 10 1 .25 .111 .063 .04 " << endl;
    dominantseptakkorde_kontrolle << "f1   0    4096 10 1 .5 .333 .25 .2 .167 .143 .125 .111 .1  " << endl;
  // Flöte
    // dominantseptakkorde_kontrolle << "f1   0    4096 10 1 .45 .71 .16 .14 .032 .013 .01" << endl;
    dominantseptakkorde_kontrolle << ";ins	strt	dur	amp(p4)	freq(p5)" << endl;

    cout << "Daten der verstimmten Akkorde werden in die Ausgabedatei geschrieben." << endl;
    double zeit_verstimmt = 0.0;
    double zeit_kontrolle = 0.0;
    for(int i = 0; i < anzahl_akkorde; i++)
    {
      double dauer = 2.5; // Dauer der Akkorde
      double kurze_pause = 0.5; // Abstand zwischen Akkorden
      double lange_pause = 3.0; // Abstand zwischen Akkordpaaren
      double amp = 3750; // Lautstärke
	
//      dominantseptakkorde_ausgabe_liste << der_d7.rein(0) << " ";
//      dominantseptakkorde_ausgabe_liste << der_d7.rein(1) << " ";
//      dominantseptakkorde_ausgabe_liste << der_d7.rein(2) << " ";
//      dominantseptakkorde_ausgabe_liste << der_d7.rein(3) << endl;
//      dominantseptakkorde_ausgabe_liste << der_d7.verstimmt(0) << " ";
//      dominantseptakkorde_ausgabe_liste << der_d7.verstimmt(1) << " ";
//      dominantseptakkorde_ausgabe_liste << der_d7.verstimmt(2) << " ";
//      dominantseptakkorde_ausgabe_liste << der_d7.verstimmt(3) << endl << endl;
      dominantseptakkorde_ausgabe_liste << der_d7.akkordton(3) << ": " << der_d7.rein(3) << " " << der_d7.verstimmt(3) << endl;
      dominantseptakkorde_ausgabe_liste << der_d7.akkordton(2) << ": " << der_d7.rein(2) << " " << der_d7.verstimmt(2) << endl;
      dominantseptakkorde_ausgabe_liste << der_d7.akkordton(1) << ": " << der_d7.rein(1) << " " << der_d7.verstimmt(1) << endl;
      dominantseptakkorde_ausgabe_liste << der_d7.akkordton(0) << ": " << der_d7.rein(0) << " " << der_d7.verstimmt(0) << endl << endl;
	
      dominantseptakkorde_akkorde << der_d7.akkordton(3) << ": " << der_d7.rein(3) << " " << endl;
      dominantseptakkorde_akkorde << der_d7.akkordton(2) << ": " << der_d7.rein(2) << " " << endl;
      dominantseptakkorde_akkorde << der_d7.akkordton(1) << ": " << der_d7.rein(1) << " " << endl;
      dominantseptakkorde_akkorde << der_d7.akkordton(0) << ": " << der_d7.rein(0) << " " << endl << endl;
	
	dominantseptakkorde_verstimmt << "i3\t" << zeit_verstimmt << "\t" << dauer << "\t" << amp << "\t" << frequenztabelle.frequenz(der_d7.verstimmt(0)) << endl;
	dominantseptakkorde_verstimmt << "i3\t" << zeit_verstimmt << "\t" << dauer << "\t" << amp << "\t" << frequenztabelle.frequenz(der_d7.verstimmt(1)) << endl;
	dominantseptakkorde_verstimmt << "i3\t" << zeit_verstimmt << "\t" << dauer << "\t" << amp << "\t" << frequenztabelle.frequenz(der_d7.verstimmt(2)) << endl;
	dominantseptakkorde_verstimmt << "i3\t" << zeit_verstimmt << "\t" << dauer << "\t" << amp << "\t" << frequenztabelle.frequenz(der_d7.verstimmt(3)) << endl;
	zeit_verstimmt += dauer + lange_pause;

	dominantseptakkorde_kontrolle << "i3\t" << zeit_kontrolle << "\t" << dauer << "\t" << amp << "\t" << frequenztabelle.frequenz(der_d7.rein(0)) << endl;
	dominantseptakkorde_kontrolle << "i3\t" << zeit_kontrolle << "\t" << dauer << "\t" << amp << "\t" << frequenztabelle.frequenz(der_d7.rein(1)) << endl;
	dominantseptakkorde_kontrolle << "i3\t" << zeit_kontrolle << "\t" << dauer << "\t" << amp << "\t" << frequenztabelle.frequenz(der_d7.rein(2)) << endl;
	dominantseptakkorde_kontrolle << "i3\t" << zeit_kontrolle << "\t" << dauer << "\t" << amp << "\t" << frequenztabelle.frequenz(der_d7.rein(3)) << endl;
	zeit_kontrolle += dauer + kurze_pause;
	dominantseptakkorde_kontrolle << "i3\t" << zeit_kontrolle << "\t" << dauer << "\t" << amp << "\t" << frequenztabelle.frequenz(der_d7.verstimmt(0)) << endl;
	dominantseptakkorde_kontrolle << "i3\t" << zeit_kontrolle << "\t" << dauer << "\t" << amp << "\t" << frequenztabelle.frequenz(der_d7.verstimmt(1)) << endl;
	dominantseptakkorde_kontrolle << "i3\t" << zeit_kontrolle << "\t" << dauer << "\t" << amp << "\t" << frequenztabelle.frequenz(der_d7.verstimmt(2)) << endl;
	dominantseptakkorde_kontrolle << "i3\t" << zeit_kontrolle << "\t" << dauer << "\t" << amp << "\t" << frequenztabelle.frequenz(der_d7.verstimmt(3)) << endl;
	zeit_kontrolle += dauer + lange_pause;

  der_d7.neuer_wert();
    }

    cout << "Erstellung der Audiodatei dominantseptakkorde_verstimmt.wav" << endl;
    const string system_verstimmt =  "csound -o dominantseptakkorde_verstimmt_" + datum + ".wav instrument.orc " + dateiname_dominantseptakkorde_verstimmt;
    system(system_verstimmt.c_str());

    cout << "Erstellung der Audiodatei dominantseptakkorde_kontrolle.wav" << endl;
    const string system_kontrolle =  "csound -o dominantseptakkorde_kontrolle_" + datum + ".wav instrument.orc " + dateiname_dominantseptakkorde_kontrolle;
    system(system_kontrolle.c_str());

    return 0;
}
